import terrylib.*;

class Main {
	var bagX:Float;
	var bagY:Float;

	var bagWidth:Int;
	var bagHeight:Int;

	var starX:Array<Float>;
	var starY:Array<Float>;

	var starWidth:Array<Int>;
	var starHeight:Array<Int>;
	var starState:Array<Int>; //0 in bag, 1 holding, 2 placed


	var cookiePicked:Array<Bool>;
	var moteEaten:Array<Bool>;
	var cookieRects:Array<Array<Int>> = [
	[305,218,84,83],
	[340,218,84,83],
	[372,218,84,83],
	[400,218,84,83],
	[430,218,84,83],
	[460,218,84,83]
	];

	// new() is a special function that is called on startup.
	function new() {

		starX = new	Array<Float>();
		starY = new	Array<Float>();
		starWidth = new	Array<Int>();
		starHeight = new Array<Int>();
		starState = new Array<Int>();
		cookiePicked = [false,false,false,false,false,false];
		moteEaten = [false,false,false,false,false,false,false,false,false,false,false];

		Gfx.loadimage("bed_mouth_closed");	
		Gfx.loadimage("bed_mouth_open");	
		Gfx.loadimage("cookie0");	
		Gfx.loadimage("cookie1");	
		Gfx.loadimage("cookie2");	
		Gfx.loadimage("cookie3");	
		Gfx.loadimage("cookie4");	
		Gfx.loadimage("cookie5");	
		Gfx.loadimage("hand0");	
		Gfx.loadimage("hand0_hover");	
		Gfx.loadimage("hand0_grip");	
		Gfx.loadimage("hand0_cookiegrab");	
		Gfx.loadimage("hand0_motehold");	
		Gfx.loadimage("hand0_motehold2");	
		Gfx.loadimage("hand1");	
		Gfx.loadimage("hand2");	
		Gfx.loadimage("tray_back");	
		Gfx.loadimage("tray_front");	
		Gfx.loadimage("packet_front_closed");	
		Gfx.loadimage("packet_front_open");	
		Gfx.loadimage("side_mouth_closed");	
		Gfx.loadimage("side_mouth_open");	
		Gfx.loadimage("sidebed");	
		Gfx.loadimage("topbed");	
		Gfx.loadimage("packet_back");	
		Gfx.loadimage("mote");	
	}

	var lines1:Array<String> = [
		"The only thing better than bed",
		"is biscuits in bed."
	];

	var lines2:Array<String> = [
		"Ah no, this can't be the end :("
	];

	var lines3:Array<String> = [
		"Well, time for bed!",
		"Night Night"
	];

	var state:Int=0;
	var stateProgress = 0;
	var handoffsetx = 74;
	var handoffsety = 88;


	function overlaps(x:Float,y:Float,bx:Float,by:Float,bw:Float,bh:Float):Bool{
		return 
			(x>=bx) &&
			(x<=bx+bw-1) &&
			(y>=by) &&
			(y<=by+bh-1);
	}

	var moteCoords = [
	[166,36],
	[284,43],
	[440,58],
	[249,73],
	[450,130],
	[304,171],
	[173,279],
	[303,302],
	[390,292],
	[166,433],
	[235,438]
	];

	var moteLines = [
	"mm, delicious and sweet chocolate",
	"an old scab",
	"huh, toast crumb :( ",
	"fluff",
	"uh, that's a bug",
	"small fragment of dried leaf",
	"tiny flake of dry skin",
	"small toenail clipping",
	"ooh a chunk of hazelnut. crunchy!",
	"fragment of old cornflake",
	"is that a tiny filament of poop ?"
	];

	var holdMouse:Bool=false;
	var handX:Int=0;
	var handY:Int=0;
	var my:Int=0;
	var packOpened = false;
	var timer = 0;
	var heldCookie = -1;
	var heldMote = -1;
	var cookiesEaten=0;
	var motesEaten=0;
	var eatAnim:Int=0;
	var moteTextDisplay:Bool=false;
	function update() {
		var mx=Mouse.x;
		var my=Mouse.y;
		
		if (state==0){	
			Gfx.cls(0xff000000);
			if (Mouse.leftclick()){
				stateProgress++;
				if (stateProgress>=lines1.length){
					state++;
					stateProgress = 0;
					return;
				}
			}
			Text.display(Gfx.CENTER,Gfx.screenheight/2-15,lines1[stateProgress]);	
		} else if (state==1){
			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(0,0,"packet_front_closed");	
			var overlapping = overlaps(mx,my,267,186,323,179);

			if (Mouse.leftheld()){
				Gfx.drawimage(Mouse.x-handoffsetx,Mouse.y-handoffsety,"hand0_grip");	
				if (overlapping&&Mouse.leftclick()){
					state++;
				}
			} else {
				if (overlapping){
					Gfx.drawimage(Mouse.x-handoffsetx,Mouse.y-handoffsety,"hand0_hover");	
				} else {
					Gfx.drawimage(Mouse.x-handoffsetx,Mouse.y-handoffsety,"hand0");	
				}
			}
		} else if (state==2){
			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(0,0,"packet_back");	
			Gfx.drawimage(0,0,"tray_back");	
			for (i in 0...6){
				Gfx.drawimage(0,0,"cookie"+(5-i));					
			}
			Gfx.drawimage(0,0,"tray_front");	
			Gfx.drawimage(0,0,"packet_front_open");	


			var overlapping = overlaps(mx,my,267,186,323,179)||overlaps(mx,my,200,321,181,161);

			if (Mouse.leftheld()){
				Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_grip");	
				if (overlapping&&Mouse.leftclick()){
					state++;
					timer=0;
					handX=mx-handoffsetx;
					handY=my-handoffsety;
				}
			} else {
				if (overlapping){
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_hover");	
				} else {
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0");	
				}
				holdMouse=true;
			}			
		} else if (state==3){
			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(timer,0,"packet_back");	
			Gfx.drawimage(0,0,"tray_back");	
			for (i in 0...6){
				Gfx.drawimage(0,0,"cookie"+(5-i));					
			}
			Gfx.drawimage(0,0,"tray_front");	
			Gfx.drawimage(timer,0,"packet_front_open");	
			Gfx.drawimage(handX+timer,handY,"hand0_grip");

			timer+=4;
			if (timer>=500){
				state++;
			}
		} if (state==4){
			var overlappingany = false;	
			if (heldCookie == -1){		
				for (i in 0...6) {
					var j=5-i;
					if (cookiePicked[j]) {
						continue;
					}
					var rect = cookieRects[i];
					var overlapping = overlaps(mx,my,rect[0],rect[1],rect[2],rect[3]);
					overlappingany = overlappingany || overlapping;
					if (Mouse.leftheld()&&overlapping){
						if (Mouse.leftclick()){
							heldCookie=j;
							cookiePicked[j]=true;
							break;
						}
					} else {
						holdMouse=true;
					}			

				}
			}


			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(0,0,"tray_back");	
			if (eatAnim>0){
				eatAnim--;
			}
			Gfx.drawimage(0,0,((eatAnim/5)%2==0)?"side_mouth_open":"side_mouth_closed");

			for (i in 0...6){
				if (cookiePicked[i]==false){
					Gfx.drawimage(0,0,"cookie"+(5-i));					
				}
			}

			Gfx.drawimage(0,0,"tray_front");	

			if (heldCookie>=0){
				var cx=0-cookieRects[heldCookie][0]+mx-handoffsetx+40;
				var cy=0-cookieRects[heldCookie][1]+my-handoffsety+20;
				Gfx.drawimage(cx,cy,"cookie"+heldCookie);

				if (overlaps(mx,my,92,246,175,178)){
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_hover");
					if (Mouse.leftclick()){
						heldCookie=-1;
						cookiesEaten++;
						if (cookiesEaten==6){
							state++;
						}
						eatAnim=30;
					}	
				} else {
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_cookiegrab");	
				}
			} else if (Mouse.leftheld()){
				Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_grip");	
			} else if (overlappingany){
				Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_hover");	
			} else {
				Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0");	
			}


		} else if (state==5){

			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(0,0,"tray_back");	
			Gfx.drawimage(0,0,"tray_front");	
			Gfx.drawimage(0,0,"side_mouth_open");


			var overlapping = overlaps(mx,my,267,186,323,179);

			if (Mouse.leftheld()){
				Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_grip");	
				if (overlapping&&Mouse.leftclick()){
					state++;
					timer=0;
					handX=mx-handoffsetx;
					handY=my-handoffsety;
				}
			} else {
				if (overlapping){
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0_hover");	
				} else {
					Gfx.drawimage(mx-handoffsetx,my-handoffsety,"hand0");	
				}
				holdMouse=true;
			}			
		} else if (state==6){
			Gfx.drawimage(0,0,"sidebed");
			Gfx.drawimage(0,0,"side_mouth_open");
			Gfx.drawimage(timer,0,"tray_back");	
			Gfx.drawimage(timer,0,"tray_front");	
			Gfx.drawimage(handX+timer,handY,"hand0_grip");

			timer+=4;
			if (timer>=500){
				state++;
			}
		} else if (state==7){			
			Gfx.cls(0xff000000);
			Gfx.drawimage(0,0,"side_mouth_open");
			if (Mouse.leftclick()){
				stateProgress++;
				if (stateProgress>=lines2.length){
					state++;
					stateProgress = 0;
					return;
				}
			}
			Text.display(Gfx.CENTER,Gfx.screenheight/2-15,lines2[stateProgress]);	
		} else if (state==8){
			if (moteTextDisplay){
				Gfx.cls(0xff000000);
				Text.display(Gfx.CENTER,Gfx.screenheight/2-15,moteLines[motesEaten-1]);				
				if (Mouse.leftclick()){
					moteTextDisplay=false;
					if (motesEaten==11){
						state++;
					}
				}
				return;
			}
			var overlappingany = false;	
			if (heldMote == -1){		
				for (j in 0...11) {
					if (moteEaten[j]) {
						continue;
					}
					var overlapping = overlaps(mx,my,moteCoords[j][0]-3,moteCoords[j][1]-3,11,11);
					overlappingany = overlappingany || overlapping;
					if (Mouse.leftheld()){
						if (overlapping && Mouse.leftclick()){
							heldMote=j;
							moteEaten[j]=true;
							break;
						}
					} else {
						holdMouse=true;
					}			
				}
			}

			Gfx.drawimage(0,0,"topbed");
			if (eatAnim>0){
				eatAnim--;
			}
			Gfx.drawimage(0,0,((eatAnim/5)%2==0)?"bed_mouth_open":"bed_mouth_closed");
			for (i in 0...11){
				if (moteEaten[i]){
					continue;
				}
				Gfx.drawimage(moteCoords[i][0],moteCoords[i][1],"mote");
			}

			var mox=0;//-30;
			var moy=0;//30;
			if (heldMote>=0){

				if (overlaps(mx,my,511,338,130,130)){
					var cx=mx-handoffsetx+93+mox;
					var cy=my-handoffsety+77+moy;
					Gfx.drawimage(mx-handoffsetx+mox,my-handoffsety+moy,"hand0_motehold2");
					Gfx.drawimage(cx,cy,"mote");
					if (Mouse.leftclick()){
						heldMote=-1;
						motesEaten++;
						moteTextDisplay=true;
						eatAnim=30;
					}	
				} else {

					var cx=mx-handoffsetx+103+mox;
					var cy=my-handoffsety+69+moy;
					Gfx.drawimage(mx-handoffsetx+mox,my-handoffsety+moy,"hand0_motehold");	
					Gfx.drawimage(cx,cy,"mote");
				}
			} else if (Mouse.leftheld()){
				Gfx.drawimage(mx-handoffsetx+mox,my-handoffsety+moy,"hand0_motehold");	
			} else if (overlappingany){
				Gfx.drawimage(mx-handoffsetx+mox,my-handoffsety+moy,"hand0_hover");	
			} else {
				Gfx.drawimage(mx-handoffsetx+mox,my-handoffsety+moy,"hand0_cookiegrab");	
			}
		}else if (state==9){			
			Gfx.cls(0xff000000);
			if (Mouse.leftclick()){
				stateProgress++;
				if (stateProgress>=lines3.length){
					state++;
					stateProgress = 0;
					return;
				}
			}
			Text.display(Gfx.CENTER,Gfx.screenheight/2-15,lines3[stateProgress]);	
		} 
	}
}